%                  Universita' di Ferrara                          %
%                                                                  %
%              Corso di informatica industriale                    %
%                                                                  %
%               Funzione elenco nomi - esercizio 5                 %
%           Esercitazione in laboratorio del 13/2/2009             %
%******************************************************************%
%
%       function nuovinomi=elenco(nomi)
%
%funzione che gestisce un elenco di nomi. In ingresso prende un vettore di
%nomi (stringhe), restituisce il vettore modificato

function nuovinomi=elenco(nomi)

%Creazione men: per prima cosa occorre che l'utente sia a conoscenza
%dell'esistenza di un men e delle opzioni di scelta; per far ci 
%sufficiente visualizzare delle stringe sul command window che indichino le
%opzioni disponibili
disp('selezionare un azione scegliendo il numero associato');
disp('1: insersci un nome');
disp('2: cancella un nome');
disp('3: cerca un nome');
disp('4: esci');
scelta=input('scelta: ');

%Le righe di codice precedenti hanno la SOLA funzione di visualizzare il
%men. Per far si che sia realmente un menu, occorre valutare con un test
%il contenuto della scelta effettuata (variabile scelta)

%A tal scopo, l'uso della struttura switch/case  consigliabile, in quando
%si hanno un numero di opzioni finite e note a priori

switch scelta
    case 1      %Inserisco nome
        nome=input('inserisci il nome: ','s'); %prendo il nome da CW
        nomi=[nomi;{nome}]; %aggiungo il nome in coda al vettore di nomi
    case 2      %Cancello nome
        nome=input('inserisci il nome da cancellare: ','s'); %prendo nome da CW
        %per cancellare un nome in elenco, per prima cosa devo trovarlo! il
        %tutto si traduce nella ricerca dell'indice che "punta" al nome nel
        %vettore. La strcmp ci viene in aiuto
        dacancellare=strcmp(nomi, nome); 
        %noto l'indice, basta porre la riga corrispondente il valore nullo.
        nomi(dacancellare)=[]
    case 3      %cerca nome
        nome=input('inserisci il nome: ','s');  %prendo nome da CW
        %Come nel caso 2, uso la strcmp per individuare l'indice del nome
        %ricercato
        trovato=strcmp(nomi, nome);
        
        %Se la ricerca successo, visualizzo tutti i risultati ottenuti
        if (any(trovato))
         disp('Trovato!')
         disp( nomi(trovato));
       end        
    case 4        
        disp('esco')
end

%imposto l'uscita della funzione
nuovinomi=nomi;