%                  Universita' di Ferrara                          %
%                                                                  %
%              Corso di informatica industriale                    %
%                                                                  %
%               Funzione datasuccessiva - esercizio 2              %
%           Esercitazione in laboratorio del 13/2/2009             %
%******************************************************************%
%
%       function domani=datasuccessiva(oggi)
%
%In ingresso prende una data, in formato vettore (1x3) gg/mm/aa
% e restituisce un vettore (1x3) con lo stesso formato contenente il giorno
% successivo

function domani=datasuccessiva(oggi)

%Non  necessario, ma vien comodo dichiare le variabili giorno, mese e
%anno. Al contrario, dovrei usare il vettore oggi, richiamando i vari
%elementi ( oggi(1), oggi(2),oggi(3) )
giorno=oggi(1);
mese=oggi(2);
anno=oggi(3);

if mese==12   %Se  dicembre
    if giorno==31 %e se  il 31, allora  l'ultimo dell'anno e
        giorno=1; %azzero giorno e mese ad 1
        mese=1;
        anno=anno+1; %aumento l'anno di 1 
    else
        %altrimenti  un giorno qualsiasi di dicembre e incremento solo il
        %giorno
        giorno=giorno+1; 
    end
elseif mese==2  %Se  febbraio
    if bisestile(anno)  %e l'anno  bisestile
        if giorno==29  %ed  il 29, ultimo giorno
            mese=3; %allora domani  marzo
            giorno=1; %resetto il giorno ad 1  
        else
            giorno=giorno+1; %se non  il 29, aumento il giorno
        end
    else
        if giorno==28 %Se l'anno non  bisestile ed  il 28
            mese=3; %allora domani  marzo
            giorno=1; %resetto il giorno ad 1  
        else
            giorno=giorno+1;%Altrimenti  un giorno qualsiasi, aumento di 1
        end
    end
elseif mese==4|mese==6|mese==9|mese==11 %Se  un mese con 30 gg
    if giorno==30 %ed  il 30esimo gg
        giorno=1;   %allora domani  il primo giorno del mese 
        mese=mese+1; %successivo
    else
        giorno=giorno+1; %altrimenti  una giornata normale
    end
else
    %se non rientra in nessun caso visto, il mese corrente 
    %necessariamente un mese di 31 gg
    if giorno==31  %se  il 31, ultimo giorno del mese
        giorno=1;  %domani  il primo giorno del mese successivo
        mese=mese+1;
    else
        giorno=giorno+1; %altrimenti  un giorno qualsiasi, aumento di 1
    end
end

%imposto l'uscita
domani=[giorno mese anno]; 

%NB: non  l'unica soluzione possibile! infatti si possono effettuare test
%differenti. Attenzione a non ottenere condizioni ridondanti!