%                  Universita' di Ferrara                          %
%                                                                  %
%              Corso di informatica industriale                    %
%                                                                  %
%                 Funzione menu - esercizio 3                      %
%           Esercitazione in laboratorio del 13/2/2009             %
%******************************************************************%
%
%       function out=menu(vettore)
%
%la funzione prende in ingresso un vettore e lascia all'utente l'operazione
%da eseguire sul vettore (media, massimo, minimo

function out=menu(vettore)


%Creazione men: per prima cosa occorre che l'utente sia a conoscenza
%dell'esistenza di un men e delle opzioni di scelta; per far ci 
%sufficiente visualizzare delle stringe sul command window che indichino le
%opzioni disponibili
disp('selezionare un azione');
disp('1: calcolo della media');
disp('2: calcolo del massimo');
disp('3: calcolo del minimo');
disp('4: esci');
scelta=input('scelta: ');

%Le righe di codice precedenti hanno la SOLA funzione di visualizzare il
%men. Per far si che sia realmente un menu, occorre valutare con un test
%il contenuto della scelta effettuata (variabile scelta)

%A tal scopo, l'uso della struttura switch/case  consigliabile, in quando
%si hanno un numero di opzioni finite e note a priori

switch scelta
    case 1 
        out=mean(vettore);
    case 2 
        out=max(vettore);
    case 3 
        out=min(vettore);
    case 4        
        %in questo caso, uscire corrisponde a non eseguire nessuna
        %operazione
        disp('esco')
end
