%                  Universita' di Ferrara                          %
%                                                                  %
%              Corso di informatica industriale                    %
%                                                                  %
%               Funzione pari/dispari - esercizio 7                %
%           Esercitazione in laboratorio del 13/2/2009             %
%******************************************************************%
%
%       function paridispari
%
% la funzione esegue il gioco pari/dispari, player VS PC
%REGOLE:
% 1)al player spetta la scelta tra pari e dispari
% 2)Il giocatore sceglie un numero intero, tra 0 e 5 compresi (la mano
% umana permette di contare da 0 a 5)
% 3)la somma del numero scelto, con quello scelto dal pc, determina il
% numero da valutare: se questo  pari/dispari, e il giocatore ha
% indovinato, allora vince; in caso contrario il vincitore  il pc


function paridispari

%NB: La funzione non prende niente in ingresso e non fornisce un uscita!
%  una scelta, posso anche creare una funzione che dia per uscita un
% valore logico (1 in caso di vittoria, 0 in caso di sconfitta) e che
% prenda in ingresso la scelta pari/dispari e il numero del giocatore

%prendo da Command Window la scelta del giocatore
scelta=input('1 per dispari, 0 per pari ')

%Prendo da Command Window il numero scelto dal giocatore
numero=input('butta un numero (da 0a 5) ')

%NB:  possibile sostituire la riga di codice con le seguenti righe
%commentate, che permettono un controllo effettivo dell'inserimento del
%numero (per esempio se non appartiene all'intervallo richiesto).
%Si pu migliorare il controllo sui dati immessi valutando se si immettono
%numeri interi o meno
% numero=-1;
% while numero>5 || numero<0
% numero=input('butta un numero (da 0a 5) ')
% end

%scelta casuale del numero del pc.
% NB: non  l'unico modo per generare un numero casuale! altre soluzioni
% (compatibili) sono ben accette
numeropc=floor(6*rand(1))

%si sommano i numeri
totale=numero+numeropc

%si valuta con un if chi vince: il test logico  vero (vittoria) se il
%resto della somma del numero con 2  pari al valore di scelta del
%giocatore
if rem(totale,2)==scelta
    disp('hai vinto')
else
    disp('ho vinto io')
end


% NB: le soluzione del problema non  unica!! infatti, si ottiene il
% medesimo risultato senza usare la rem, ma valutando i 4 casi possibili,
% in uno o pi if. Altre soluzioni ancora sono possibili, a seconda della
% logica utilizzata.
% Spesso in problemi di questo tipo non c' una soluzione migliore in
% assoluto, ma solo una migliore rispetto ad un altra rispetto a certe
% caratteristiche (quantit di righe di codice, meno memoria richiesta,
% velocita' di esecuzione, riutilizzo del codice e altro).
