%                  Universita' di Ferrara                          %
%                                                                  %
%              Corso di informatica industriale                    %
%                                                                  %
%               Funzione separa - esercizio 4                      %
%           Esercitazione in laboratorio del 13/2/2009             %
%******************************************************************%
%
%       function [sopra,sotto]=separa(vettore,soglia)
%
% funzione che prende in ingresso un vettore (di valori, dimensione 1xn con
% n a piacere) e una soglia (valore, o meglio matrice 1x1). La funzione
% genera due vettori sopra e sotto, aventi gli elementi del vettore in
% ingresso, rispettivamente sopra la soglia e sotto la soglia
% ESEMPIO
% vettore= [2 7 4 1 8 8 9]; soglia=5;
% in uscita si avr: sopra= [7 8 8 9]
%                    sotto= [2 4 1]


function [sopra,sotto]=separa(vettore,soglia)

%per risolvere il problema basta ricordarsi che  possibile utilizzare
%vettori logici in modo intelligente, ovvero usandoli come indici di
%vettori

sopra=vettore(vettore>=soglia);

sotto=vettore(vettore<soglia);